From: Tom de Vries <tdevries@suse.de>
To: gdb-patches@sourceware.org
Subject: [PATCH] [pre-commit] Add file mode check
Date: Wed, 3 Jun 2026 14:18:56 +0200 [thread overview]
Message-ID: <20260603121856.212613-1-tdevries@suse.de> (raw)
Claude Code mentioned in a review that a source file was marked executable.
I've submitted a patch to fix this [1].
Detect this problem using pre-commit to prevent it from re-occurring.
The current unfixed state gives us (abbreviated output using "..."):
...
$ pre-commit run check-file-mode --all-files
check-file-mode.........................................................Failed
- hook id: check-file-mode
- exit code: 1
100755 ... gdb/testsuite/gdb.base/jump_multiple_objfiles.h
100755 ... gdb/testsuite/gdb.fortran/nested-funcs.f90
100755 ... gdb/testsuite/gdb.fortran/oop_extend_type.f90
100755 ... gdb/amd64-tdep.c
100755 ... gdb/testsuite/lib/compiler.cc
100755 ... gdb/testsuite/gdb.fortran/nested-funcs.exp
100755 ... gdb/testsuite/gdb.fortran/vla-type.f90
100755 ... gdb/testsuite/gdb.arch/amd64-lam.c
100755 ... gdb/testsuite/gdb.base/jump_multiple_objfiles.exp
100755 ... gdb/testsuite/gdb.testsuite/gdb_test_multiple-lbl.gdb
100755 ... gdb/testsuite/gdb.btrace/exception.exp
100755 ... gdb/testsuite/gdb.fortran/vla-type.exp
100755 ... gdb/testsuite/gdb.base/jump_multiple_objfiles.c
100755 ... gdb/testsuite/gdb.base/jump_multiple_objfiles-foo.c
100755 ... gdb/testsuite/gdb.fortran/oop_extend_type.exp
100755 ... gdb/testsuite/gdb.fortran/print_type.exp
...
Shell-checked new script gdb/contrib/check-file-mode.sh.
[1] https://sourceware.org/pipermail/gdb-patches/2026-June/227780.html
---
.pre-commit-config.yaml | 5 ++++
gdb/contrib/check-file-mode.sh | 42 ++++++++++++++++++++++++++++++++++
2 files changed, 47 insertions(+)
create mode 100755 gdb/contrib/check-file-mode.sh
diff --git a/.pre-commit-config.yaml b/.pre-commit-config.yaml
index fe8466433ac..d75468d0b48 100644
--- a/.pre-commit-config.yaml
+++ b/.pre-commit-config.yaml
@@ -112,6 +112,11 @@ repos:
additional_dependencies: ["pyyaml"]
always_run: true
require_serial: true
+ - id: check-file-mode
+ name: check-file-mode
+ language: script
+ entry: gdb/contrib/check-file-mode.sh
+ files: '^(gdb|gdbserver|gdbsupport)/.*$'
- repo: https://github.com/nmoroze/tclint
rev: v0.8.0
hooks:
diff --git a/gdb/contrib/check-file-mode.sh b/gdb/contrib/check-file-mode.sh
new file mode 100755
index 00000000000..a558731c425
--- /dev/null
+++ b/gdb/contrib/check-file-mode.sh
@@ -0,0 +1,42 @@
+#!/bin/bash
+
+# Copyright (C) 2026 Free Software Foundation, Inc.
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+set -e
+
+no_exec_files=()
+for f in "$@"; do
+ case $f in
+ */*.py|*/*.sh|*/configure)
+ continue
+ ;;
+ gdb/gstack-1.in|gdb/gcore-1.in|gdb/po/gdbtext|gdb/make-init-c|gdb/testsuite/lib/notty-wrap|gdb/testsuite/lib/pdtrace.in)
+ continue
+ ;;
+ *)
+ no_exec_files=("${no_exec_files[@]}" "$f")
+ ;;
+ esac
+done
+
+if [ ${#no_exec_files[@]} -eq 0 ]; then
+ exit 0
+fi
+
+# Flag files that are executable, but not meant to be executable.
+
+if git ls-files --stage -- "${no_exec_files[@]}" | grep '^100755 '; then
+ exit 1
+fi
base-commit: 663cb9c0428068165fc98675599442163d302d41
--
2.51.0
next reply other threads:[~2026-06-03 12:19 UTC|newest]
Thread overview: 2+ messages / expand[flat|nested] mbox.gz Atom feed top
2026-06-03 12:18 Tom de Vries [this message]
2026-06-05 11:23 ` Tom de Vries
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20260603121856.212613-1-tdevries@suse.de \
--to=tdevries@suse.de \
--cc=gdb-patches@sourceware.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox